#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int comps = atoi(argv[1]);
    int mess = atoi(argv[2]);

    int n;
    cin >> n;
    string tmp;
    cin >> tmp;
    vector<vector<int>> graph(n);
    vector<pii> edges;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        edges.push_back({a, b});
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    vector<int> color(n, -1);
    queue<int> qu;

    for (int i = 0; i < comps; ++i) {
        int v;
        while (true) {
            v = rnd.next(0, n - 1);
            if (color[v] == -1) {
                break;
            }
        }
        color[v] = i;
        qu.push(v);
    }

    while (szof(qu)) {
        int v = qu.front();
        qu.pop();

        for (int to : graph[v]) {
            if (color[to] == -1) {
                color[to] = color[v];
                qu.push(to);
            }
        }
    }

    vector<vector<int>> ngraph(comps);

    for (auto e : edges) {
        if (color[e.ff] != color[e.ss]) {
            int a = color[e.ff];
            int b = color[e.ss];
            ngraph[a].push_back(b);
            ngraph[b].push_back(a);
        }
    }

    vector<int> ncolor(comps);
    function<void(int, int, int)> dfs = [&](int v, int p, int col) {
        ncolor[v] = col;
        for (int to : ngraph[v]) {
            if (to != p) {
                dfs(to, v, 1 - col);
            }
        }
    };

    dfs(0, 0, 0);

    for (int& num : color) {
        num = ncolor[num];
    }

    for (int i = 0; i < mess; ++i) {
        color[rnd.next(0, n - 1)] ^= rnd.next(0, 1);
    }

    cout << n << "\n";
    for (int c : color) {
        cout << c;
    }
    cout << "\n";

    for (auto e : edges) {
        cout << e.ff + 1 << " " << e.ss + 1 << "\n";
    }

    return 0;
}