// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<pii>> graph(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back({b, i});
		graph[b].push_back({a, i});
	}

	ll ans = 0;
	vector<int> cnt_edges(m);

	for (int i = 0; i < n; ++i) {
		sort(graph[i].begin(), graph[i].end(), [&](auto& a, auto& b) {
			return szof(graph[a.ff]) < szof(graph[b.ff]) || (szof(graph[a.ff]) == szof(graph[b.ff]) && a.ff < b.ff);
		});
	}

	vector<pii> neibs(n, {-1, -1});

	for (int i = 0; i < n; ++i) {
		for (auto to : graph[i]) {
			neibs[to.ff] = {i, to.ss};
		}
		for (auto to1 : graph[i]) {
			if (szof(graph[to1.ff]) > szof(graph[i]) || (szof(graph[to1.ff]) == szof(graph[i]) && to1.ff > i)) {
				break;
			}
			for (auto to2 : graph[to1.ff]) {	
				if (szof(graph[to2.ff]) > szof(graph[to1.ff]) || (szof(graph[to2.ff]) == szof(graph[to1.ff]) && to2.ff > to1.ff)) {
					break;
				}
				if (neibs[to2.ff].ff == i) {
					cnt_edges[to1.ss]++;
					cnt_edges[to2.ss]++;
					cnt_edges[neibs[to2.ff].ss]++;
					ans -= 3;
				}
			}
		}
	}

	for (int i = 0; i < m; ++i) {
		ans += (ll) cnt_edges[i] * cnt_edges[i];
	}

	cout << ans / 2 << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
