#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	int m = inf.readInt();
	inf.readEoln();
	vector<string> field;

	for (int i = 0; i < n; ++i) {
		field.push_back(inf.readLine());
	}

	auto check_outp = [&](auto& stream) {
		vector<string> cur_field;
		for (int i = 0; i < n; ++i) {
			cur_field.push_back(stream.readLine(format("[.#]{%d}", m)));
		}

		vector<vector<bool>> used(n, vector<bool>(m));

		function<bool(int, int, int, int)> dfs = [&](int x, int y, int px, int py) {
			used[x][y] = true;
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (!(0 <= nx && nx < n && 0 <= ny && ny < m) || cur_field[nx][ny] == '.') {
					continue;
				}
				if (used[nx][ny] && (px != nx || py != ny)) {
					return true;
				}
				if (!used[nx][ny] && dfs(nx, ny, x, y)) {
					return true;
				}
			}
			return false;
		};

		int cnt = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (cur_field[i][j] == '#' && !used[i][j]) {
					if (dfs(i, j, i, j)) {
						stream.quitf(_wa, "there's cycle on black cells");
					}
					++cnt;
				}
			}
		}

		if (cnt != 1) {
			stream.quitf(_wa, "there're %d trees instead of 1", cnt);
		}

		int flips = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				flips += cur_field[i][j] != field[i][j];
			}
		}
		return flips;
	};

	int jans = check_outp(ans);
	int pans = check_outp(ouf);

	if (jans < pans) {
		quitf(_wa, "jury did %d flips, but participant did %d flips", jans, pans);
	}

	if (jans > pans) {
		quitf(_fail, "jury did %d flips, but participant did %d flips", jans, pans);
	}

	quitf(_ok, "jury and participant did %d flips", jans);

	return 0;
}