#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	cout << n << " " << m << "\n";

	vector<pii> cells;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cells.push_back({i, j});
		}
		shuffle(cells.begin() + i * m, cells.begin() + (i + 1) * m);
	}


	reverse(cells.begin(), cells.begin() + rnd.next(0, n - 1) * m);
	// shuffle(cells.begin(), cells.end());

	vector<int> dsu(n * m);
	iota(dsu.begin(), dsu.end(), 0);

	function<int(int)> get_root = [&](int v) {
		return dsu[v] == v ? v : dsu[v] = get_root(dsu[v]);
	};

	vector<vector<bool>> used(n, vector<bool>(m));

	for (auto [x, y] : cells) {
		vector<int> neibs;
		for (int d = 0; d < 4; ++d) {
			int nx = x + dx[d];
			int ny = y + dy[d];
			if (0 <= nx && nx < n && 0 <= ny && ny < m && used[nx][ny]) {
				neibs.push_back(get_root(nx * m + ny));
			}
		}
		int mem_sz = szof(neibs);
		sort(neibs.begin(), neibs.end());
		neibs.erase(unique(neibs.begin(), neibs.end()), neibs.end());
		if (szof(neibs) < mem_sz) {
			continue;
		}

		for (int neib : neibs) {
			dsu[neib] = x * m + y;
		}
		used[x][y] = true;
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << ".#"[used[i][j]];
		}
		cout << "\n";
	}

	return 0;
}