// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> field(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j] == '#';
		}
	}

	int mem = 0;
	int best = INF;
	vector<vector<int>> used(n, vector<int>(m));
	int used_cnt = 0;

	for (int mask = 0; mask < 1 << (n * m); ++mask) {
		if (__builtin_popcount(mask) >= best) {
			continue;
		}
		auto get_cell = [&](int x, int y) {
			return field[x][y] ^ ((mask >> (x * m + y)) & 1);
		};

		++used_cnt;

		function<bool(int, int, int, int)> dfs = [&](int x, int y, int px, int py) {
			used[x][y] = used_cnt;
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (!(0 <= nx && nx < n && 0 <= ny && ny < m && get_cell(nx, ny))) {
					continue;
				}
				if (used[nx][ny] == used_cnt && (nx != px || ny != py)) {
					return true;
				}
				if (used[nx][ny] != used_cnt && dfs(nx, ny, x, y)) {
					return true;
				}
			}
			return false;
		};

		int cnt = 0;
		bool fail = false;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (used[i][j] != used_cnt && get_cell(i, j)) {
					++cnt;
					if (cnt > 1) {
						fail = true;
						break;
					}
					if (dfs(i, j, i, j)) {
						fail = true;
						break;
					}
				}
			}
			if (fail) {
				break;
			}
		}

		if (!fail && cnt == 1) {
			best = __builtin_popcount(mask);
			// cerr << best << endl;
			mem = mask;
		}
	}

	// cerr << best << endl;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << ".#"[field[i][j] ^ ((mem >> (i * m + j)) & 1)];
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
