// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
// #  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> field(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j] == '#';
		}
	}

	vector<vector<tuple<ll, int, ll>>> vars(n * m + 1);
	vars[0].push_back({0, 0, 0});

	vector<map<ll, pll>> mem_go(m);
	vector<tuple<ll, int, ll>> next_vars;

	const int P = 12;

	auto decode = [&](ll mask, vector<int>& arr) {
		for (int i = 0; i < m; ++i) {
			arr[i] = mask % P - 1;
			mask /= P;
		}
	};

	auto encode = [&](vector<int> const& arr) {
		ll ret = 0;
		for (int i = 0; i < m; ++i) {
			ret = ret * P + arr[m - 1 - i] + 1;
		}
		return ret;
	};

	vector<int> used(m + 5), perm(m + 5);
	int used_cnt = 0;

	auto norm = [&](vector<int>& arr) {
		int cnt = 0;
		++used_cnt;
		for (int& num : arr) {
			if (num != -1) {
				if (used[num] != used_cnt) {
					used[num] = used_cnt;
					perm[num] = cnt++;
				}
				num = perm[num];
			}
		}
	};

	vector<int> st(m);

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			next_vars.clear();
			for (auto [mask, val, prev_mask] : vars[i * m + j]) {
				if (!mem_go[j].count(mask)) {
					auto& to = mem_go[j][mask];
					if (mask == INFL) {
						to = {INFL, -1};
					} else {
						decode(mask, st);
						if (st[j] != -1 && find(st.begin(), st.begin() + j, st[j]) == st.begin() + j && find(st.begin() + j + 1, st.end(), st[j]) == st.end()) {
							if (*max_element(st.begin(), st.end()) == 0) {
								to.ff = INFL;
							} else {
								to.ff = -1;
							}
						} else {
							st[j] = -1;
							norm(st);
							to.ff = encode(st);
						}
						decode(mask, st);
						if (j && st[j] != -1 && st[j - 1] != -1) {
							if (st[j] == st[j - 1]) {
								to.ss = -1;
							} else {
								int a = st[j - 1];
								int b = st[j];
								for (int& num : st) {
									if (num == a) {
										num = b;
									}
								}
								norm(st);
								to.ss = encode(st);
							}
						} else {
							if (st[j] != -1) {
								to.ss = mask;
							} else if (j && st[j - 1] != -1) {
								st[j] = st[j - 1];
								norm(st);
								to.ss = encode(st);
							} else {
								st[j] = m;
								norm(st);
								to.ss = encode(st);
							}
						}
					}
				}
				auto tmp = mem_go[j][mask];
				// cerr << "go " << j << " " << mask << " " << tmp.ff << " " << tmp.ss << endl;
				if (tmp.ff != -1) {
					next_vars.push_back({tmp.ff, val + (field[i][j] == 1), mask});
				}
				if (tmp.ss != -1) {
					next_vars.push_back({tmp.ss, val + (field[i][j] == 0), mask});
				}
			}

			sort(next_vars.begin(), next_vars.end());
			for (auto t : next_vars) {
				if (!szof(vars[i * m + j + 1]) || get<0>(vars[i * m + j + 1].back()) != get<0>(t)) {
					vars[i * m + j + 1].push_back(t);
				} else {
					vars[i * m + j + 1].back() = min(vars[i * m + j + 1].back(), t);
				}
			}

			// cerr << i << " " << j << endl;
			// for (auto p : vars[i * m + j + 1]) {
			// 	cerr << get<0>(p) << " " << get<1>(p) << " " << get<2>(p) << endl;
			// }
		}
	}

	ll mem = -1;
	int best = INF;
	for (auto [mask, val, prev_mask] : vars.back()) {
		bool ok = false;
		if (mask == INFL) {
			ok = true;
		} else {
			decode(mask, st);
			ok = *max_element(st.begin(), st.end()) <= 0;
		}
		if (ok && best > val) {
			best = val;
			mem = mask;
		}
	}

	cerr << best << endl;

	int pos = n * m;
	vector<vector<int>> ans(n, vector<int>(m));
	while (pos) {
		ll prev = -1;
		for (auto [mask, val, prev_mask] : vars[pos]) {
			if (mask == mem) {
				prev = prev_mask;
				break;
			}
		}
		if (mem != INFL) {
			decode(mem, st);
			if (st[(pos - 1) % m] != -1) {
				ans[(pos - 1) / m][(pos - 1) % m] = 1;
			}
		}
		--pos;
		mem = prev;
	}

	for (auto& v : ans) {
		for (int d : v) {
			cout << ".#"[d];
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
