#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif

#include <vector>

using namespace std;

unsigned long long check(vector<unsigned long long> const &a, unsigned int l, unsigned int r, bool jury = false) {
    if (l < 1 || l > a.size() || r < 1 || r > a.size() || l >= r) {
        quitf(jury ? _fail : _wa,
              "Incorrect range%s, expected 1 <= %d < %d <= %d",
              jury ? " in jury's ans" : "", l, r, a.size());
    }
    unsigned long long lsum = 0, rsum = 0;
    for (unsigned int i = 0; i <= l - 1; i++) {
        lsum += a[i];
    }
    for (unsigned int i = r - 1; i < a.size(); i++) {
        rsum += a[i];
    }
    return lsum > rsum ? lsum - rsum : rsum - lsum;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector<unsigned long long> a(n);
    for (unsigned int i = 0; i < static_cast<unsigned int>(n); i++) {
        a[i] = inf.readUnsignedLong();
    }

    unsigned long long cor = ans.readUnsignedLong(), out = ouf.readUnsignedLong();
    int lans = ans.readInt(), rans = ans.readInt(), l = ouf.readInt(), r = ouf.readInt();
    if (check(a, lans, rans, true) != cor) {
        quitf(_fail, "Jury has invalid answer");
    } else {
        auto diff = check(a, l, r);
        if (diff != out) {
            quitf(_wa, "Answer %llu doesn't correspond to actual diff %llu", out, diff);
        }

        if (cor < out) {
            quitf(_wa, "Jury has better answer");
        } else if (cor > out) {
            quitf(_fail, "Contestant has better answer");
        } else {
            quitf(_ok, "Ok %llu", out);
        }
    }

}
