// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
// #  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> field(n, vector<int>(m));
	int sx = -1, sy = -1, fx = -1, fy = -1;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			if (s[j] == '#') {
				field[i][j] = 1;
			}
			if (s[j] == 's') {
				sx = i; sy = j;
			}
			if (s[j] == 'f') {
				fx = i; fy = j;
			}
		}
	}

	vector<vector<bool>> used(n, vector<bool>(m));
	bool used_dir[2] = {false, false};
	queue<pii> qu;
	qu.push({sx, sy});
	used[sx][sy] = true;
	while (szof(qu)) {
		auto [x, y] = qu.front();
		qu.pop();
		for (int d = 0; d < 4; ++d) {
			int nx = x + dx[d];
			int ny = y + dy[d];
			if (0 <= nx && nx < n && 0 <= ny && ny < m && field[nx][ny] == 0 && !used[nx][ny]) {
				used_dir[d % 2] = true;
				used[nx][ny] = true;
				qu.push({nx, ny});
			}
		}
	}

	if (!used[fx][fy]) {
		cout << "-1\n";
		cerr << "case 1" << endl;
	} else if (!used_dir[0] || !used_dir[1]) {
		cout << abs(fx - sx) + abs(fy - sy) << "\n";
		if (sx != fx) {
			cerr << "case 2.1" << endl;
		}
		if (sy != fy) {
			cerr << "case 2.2" << endl;
		}
	} else {
		cout << (abs(fx - sx) + abs(fy - sy)) % 2 << "\n";
		cerr << "case 3" << endl;
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
