// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

void solve() {
	string s;
	cin >> s;

	vector<map<int, int>> dp(szof(s));

	function<int(int, int)> calc = [&](int l, int r) {
		if (s[l] == s[r - 1]) {
			return 0;
		}
		if (dp[l].count(r)) {
			return dp[l][r];
		}
		int& val = dp[l][r];
		set<int> vars;
		for (int mid = l + 1; mid < r; ++mid) {
			vars.insert(calc(l, mid) ^ calc(mid, r));
		}
		val = 0;
		while (vars.count(val)) {
			++val;
		}
		return val;
	};

	if (calc(0, szof(s))) {
		cout << "Win\n";
	} else {
		cout << "Lose\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
