#include "testlib.h"
#include <vector>
#include <algorithm>

using namespace std;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        a[i] = inf.readInt() - 1;
    }
    for (int i = 0; i < n; ++i) {
        b[i] = inf.readInt() - 1;
    }

    int k = ouf.readInt(0, 15, "k");
    for (int i = 0; i < k; ++i) {
        int c = ouf.readInt(1, n, format("c[%d]", i));

        vector<bool> used(n);
        for (int j = 0; j < c; ++j) {
            int index = ouf.readInt(1, n, format("index[%d][%d]", i, j)) - 1;
            if (used[index]) {
                quitf(_wa, "duplicate index %d in transformation %d", index, i);
            }
            used[index] = true;
        }

        vector<int> aa;
        aa.reserve(n);
        for (int j : a) {
            if (used[j]) {
                aa.push_back(j);
            }
        }
        reverse(aa.begin(), aa.end());
        for (int j : a) {
            if (!used[j]) {
                aa.push_back(j);
            }
        }

        a.swap(aa);
    }

    for (int i = 0; i < n; ++i) {
        if (a[i] != b[i]) {
            quitf(_wa, "%d-th index differs", i);
        }
    }

    quitf(_ok, "%d transformations", k);
}
