#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> lcs(const vector<int>& a, const vector<int>& b) {
    vector<int> ans;
    int i = a.size() - 1;
    for (int j = b.size() - 1; j >= 0; --j) {
        while (i >= 0 && a[i] != b[j]) {
            --i;
        }
        if (i == -1) {
            break;
        }
        ans.push_back(a[i]);
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
    }

    vector<vector<int>> ans;

    while (a != b) {
        auto c = lcs(a, b);

        vector<bool> in_lcs(n);
        for (int i : c) {
            in_lcs[i] = true;
        }

        ans.emplace_back();
        for (int i = 0; i < n; ++i) {
            if (!in_lcs[i]) {
                ans.back().push_back(i + 1);
            }
        }

        vector<int> new_a;
        for (int i : a) {
            if (!in_lcs[i]) {
                new_a.push_back(i);
            }
        }
        reverse(new_a.begin(), new_a.end());
        for (int i : a) {
            if (in_lcs[i]) {
                new_a.push_back(i);
            }
        }

        a.swap(new_a);
    }

    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].size();
        for (int j : ans[i]) {
            cout << " " << j;
        }
        cout << "\n";
    }

    return 0;
}
