// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		--b[i];
	}

	vector<int> whereb(n);
	for (int i = 0; i < n; ++i) {
		whereb[b[i]] = i;
	}

	// f(a) = b
	// f(1) = c

	vector<int> c(n);

	for (int i = 0; i < n; ++i) {
		c[whereb[a[i]]] = i;
	}

	function<vector<vector<int>>(vector<int> const&)> build = [&](vector<int> const& perm) {
		vector<vector<int>> ret;
		if (szof(perm) == 1) {
			return ret;
		}
		vector<int> left(perm.begin(), perm.begin() + szof(perm) / 2), right(perm.begin() + szof(perm) / 2, perm.end());
		reverse(left.begin(), left.end());
		auto res_left = build(left);
		auto res_right = build(right);
		ret.resize(max(szof(res_left), szof(res_right)));
		for (int i = 0; i < szof(res_left); ++i) {
			for (int ind : res_left[i]) {
				ret[i].push_back(ind);
			}
		}
		for (int i = 0; i < szof(res_right); ++i) {
			for (int ind : res_right[i]) {
				ret[i].push_back(ind);
			}
		}
		ret.push_back({});
		for (int i = 0; i < szof(perm) / 2; ++i) {
			ret.back().push_back(perm[i]);
		}
		return ret;
	};

	auto ans = build(c);

	cout << szof(ans) << "\n";
	for (auto& v : ans) {
		cout << szof(v) << " ";
		for (int ind : v) {
			cout << a[ind] + 1 << " ";
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
